/***********************************************************

	Def.h   Various type definitions for DesCmd.dll library

 -----------------------------------------------------------
	Author: Roland Odermatt           Date: 25.07.2000
	For   : maxon motor ag CH-6072 Sachseln
	Compil: Visual C++ V6.0     Target: Win9x & WinNT & Win2000 
	Edit  :

 ***********************************************************/

// ------------------------------------------------------------------
//							TYPE DEFINTIONS
// ------------------------------------------------------------------

#pragma pack(push,2) 		/* align on word boundaries */
typedef struct DES_SysParam
{
	short Baudrate;			//ParNb 0: R/W; 0=9600; 1=14400; 2=19200; 3=38400; 4=57600; 5=115200 baud
	short SysConfig;		//ParNb 1; R/W; System Configuration, See bit defintion
	short CurRegGainP;		//ParNb 2; R/W; Current regulation P-gain
	short CurRegGainI;		//ParNb 3; R/W; Current regulation I-gain
	short MaxCurOutput;		//ParNb 4; R/W; Max output of current regulator
	short SpeedRegGainP;	//ParNb 5; R/W; Speed regulator P-gain
	short SpeedRegGainI;	//ParNb 6; R/W; Speed regulator I-gain
	short PosRegGainP;		//ParNb 7; R/W; Position regulator P-gain
	short PosRegGainI;		//ParNb 8; R/W; Position regulator I-gain
	short PosRegGainD;		//ParNb 9; R/W; Position regulator D-gain
	short MaxSpeedError;	//ParNb 10; R/W; Limitation of speed error for the input of speed regulator
	short SettingUnitGain;	//ParNb 11; R/W; Gain of setting unit
	short SettingUnitOffset;//ParNb 12; R/W; Offset of setting unit
	short SettingUnitDelay;	//ParNb 13; R/W; Delay of setting unit
	short PeakCurrent;		//ParNb 14; R/W; Peak current in mA
	short MaxContCurrent;	//ParNb 15; R/W; Max. continuous current
	short ThermConst;		//ParNb 16; R/W; Thermal constant
	short MaxSpeed;			//ParNb 17; R/W; Maximum Speed
	short Acceleration;		//ParNb 18; R/W; Acceleration in rpm/ms^2
	short SpeedConstant;	//ParNb 19; R/W; Speed constant of motor 
	short EncResolution;	//ParNb 20; R/W; Encoder resolution in QEP
	short PolePairNumber;	//ParNb 21; R/W; Number of pole pair
	short Qep2RpmFactor;	//ParNb 22; R/W; Conversion factor from qep to rpm
	short Rpm2QepFactor;	//ParNb 23; R/W; Converion factor form rpm to qep
	short IndexOffset;		//ParNb 24; R/W; Angular offset of index pulse
	short PWM_Period;		//ParNb 25; R; PWM period in clock
	short MaxDutyCycle;		//ParNb 26; R/W; Max duty cycle
	short CurDetPhUOffset;	//ParNb 27; R/W; Offset of (phase U) current detection
	short CurDetPhVOffset;	//ParNb 28; R/W; Offset of (phase V) current detection
	short ADConvOffset;		//ParNb 29; R/W; Offset of general AD converter
	short CAN_ModuleID;		//ParNb 30; R; CAN module ID
	short CAN_ServiceID;	//ParNb 31; R; CAN service ID
	short CAN_RPDO_ID;		//ParNb 32; R; CAN RPDO ID
	short CAN_TPDO_ID;		//ParNb 33; R; CAN TPDO ID
	short CAN_BCR1;			//ParNb 34; R; CAN BCR1
	short CAN_BCR2;			//ParNb 35; R; CAN BCR2
	short CAN_OpMode;		//ParNb 36; R/W; CAN operation mode
	short CAN_RSDO_ID;		//ParNb 37; R; CAN RSDO ID
	short CAN_TSDO_ID;		//ParNb 38; R; CAN TSDO ID
	short CAN_RTR0_ID;		//ParNb 39; R; CAN RTR0 ID
	short CAN_RTR1_ID;		//ParNb 40; R; CAN RTR1 ID
	short CAN_Config;		//ParNb 41; R; CAN Config
	short CAN_LifeGuardTime;//ParNb 42; R; CAN LifeGuardTime
	short ErrorProc;		//ParNb 43; R; Error Reaction Procedure 0:disable 1:Stop/Brake
	short MaxSpeedCur;		//ParNb 44; R; Maximal speed in current control mode
	short HallAngleOffs;	//ParNb 45; R; Angle offset of hall sensors
}DES_SysParam;
#pragma pack(pop)

//System parameter numbers
#define k_Baudrate				0
#define k_SysConfig				1
#define k_CurRegGainP			2
#define k_CurRegGainI			3
#define k_MaxCurOutput			4
#define k_SpeedRegGainP			5
#define k_SpeedRegGainI			6
#define k_PosRegGainP			7
#define k_PosRegGainI			8
#define k_PosRegGainD			9
#define k_MaxSpeedError			10
#define k_SettingUnitGain		11
#define k_SettingUnitOffset		12 
#define k_SettingUnitDelay		13
#define k_PeakCurrent			14
#define k_MaxContCurrent		15
#define k_ThermConst			16
#define k_MaxSpeed				17
#define k_Acceleration			18
#define k_SpeedConstant			19
#define k_EncResolution			20
#define k_PolePairNumber		21
#define k_Qep2RpmFactor			22
#define k_Rpm2QepFactor			23
#define k_IndexOffset			24
#define k_PWM_Period			25
#define k_MaxDutyCycle			26
#define k_CurDetPhUOffset		27
#define k_CurDetPhVOffset		28
#define k_ADConvOffset			29
#define k_CAN_ModuleID			30
#define k_CAN_ServiceID			31
#define k_CAN_RPDO_ID			32
#define k_CAN_TPDO_ID			33
#define k_CAN_BCR1				34
#define k_CAN_BCR2				35
#define k_CAN_OpMode			36
#define k_CAN_RSDO_ID			37
#define k_CAN_TSDO_ID			38
#define k_CAN_RTR0_ID			39
#define k_CAN_RTR1_ID			40
#define k_CAN_Config			41
#define k_CAN_LifeGuardTime		42
#define k_ErrorProc				43
#define k_MaxSpeedCur			44
#define k_HallAngleOffs			45

//Numberd variables
#define k_SysOpStatus			128
#define k_CurrentDetDAxis		129
#define k_CurrentMeanQAxis		130
#define k_CurrentSetValue		131
#define k_RelRotorPosition		132
#define k_SpeedSetValue			133
#define k_SpeedMeanValue		134
#define k_PosSetValue			135
#define k_PosDetValue			136
#define k_StandardError			137
#define k_CAN_Error				138
#define k_CurrentDetQAxis		139
#define k_SpeedDetValue			140
#define k_ErrorHistory1			141
#define k_ErrorHistory2			142
#define k_EncoderCntr			143
#define k_EncoderCntrIdx		144
#define k_HallSensorPattern		145

// --------------------------------------------------------------------------
//							IMPORTED FUNCTIONS PROTOTYPE
// --------------------------------------------------------------------------

#define	Configuration_DllExport		extern "C" __declspec( dllexport )
#define	CommandLayer_DllExport		extern "C" __declspec( dllexport )
#define	DialogLayer_DllExport		extern "C" __declspec( dllexport )
#define	CAN_CommandLayer_DllExport	extern "C" __declspec( dllexport )
#define	CAN_DialogLayer_DllExport	extern "C" __declspec( dllexport )

//Configuration
Configuration_DllExport BOOL __stdcall DES_InitCommunication(char portName[],__int32 baudrate,DWORD timeout,DWORD trials);
Configuration_DllExport BOOL __stdcall DES_OpenCommunication(char portName[]);
Configuration_DllExport BOOL __stdcall DES_CloseCommunication(char portName[]);
Configuration_DllExport BOOL __stdcall DES_GetCommunicationSetting(char portName[],__int32* baudrate,DWORD* timeout,DWORD* trials);
Configuration_DllExport BOOL __stdcall DES_SearchCommunicationSetting(BOOL startAtBeginning,BOOL showMsg,char foundPort[]);
Configuration_DllExport BOOL __stdcall DES_InitCommunicationDlg(char portName[]);


//Command Layer
//Status Functions
CommandLayer_DllExport BOOL __stdcall DES_ReadSysStatus(char portName[],WORD* sysStatus);
CommandLayer_DllExport BOOL __stdcall DES_ReadError(char portName[],WORD* error);
CommandLayer_DllExport BOOL __stdcall DES_ClearError(char portName[]);
CommandLayer_DllExport BOOL __stdcall DES_Reset(char portName[]);
CommandLayer_DllExport BOOL __stdcall DES_Enable(char portName[],WORD enable);

//System Parameter Functions
CommandLayer_DllExport BOOL __stdcall DES_ReadTempParam(char portName[],WORD parNb,WORD parType,void* param);
CommandLayer_DllExport BOOL __stdcall DES_SetTempParam(char portName[],WORD parNb,WORD parType,void* param);
CommandLayer_DllExport BOOL __stdcall DES_ResetTempParam(char portName[]);
CommandLayer_DllExport BOOL __stdcall DES_SaveTempParam(char portName[]);
CommandLayer_DllExport BOOL __stdcall DES_ReadAllTempParam(char portName[],DES_SysParam* sysParam);
CommandLayer_DllExport BOOL __stdcall DES_SetAllTempParam(char portName[],DES_SysParam* sysParam);
CommandLayer_DllExport BOOL __stdcall DES_ReadVersion(char portName[],WORD* softVersion,WORD* hardVersion,WORD* appNb,WORD* appVersion);
CommandLayer_DllExport BOOL __stdcall DES_SetDefaultSysParam(char portName[]);

//Setting Functions
CommandLayer_DllExport BOOL __stdcall DES_SetVelocity(char portName[],short velocity);
CommandLayer_DllExport BOOL __stdcall DES_SetCurrent(char portName[],short current);
CommandLayer_DllExport BOOL __stdcall DES_StopMotion(char portName[]);

//Monitor Functions
CommandLayer_DllExport BOOL __stdcall DES_ReadVelocityIsMust(char portName[],WORD type,short* isVelocity, short* mustVelocity);
CommandLayer_DllExport BOOL __stdcall DES_ReadCurrentIsMust(char portName[],WORD type,short* isQCurrent, short* isDCurrent,short* mustCurAmp,short* currentAngle);

//Data Recording Functions
CommandLayer_DllExport BOOL __stdcall DES_SetupRecorder(char portName[],WORD samplePeriod,WORD paramNbAddress);
CommandLayer_DllExport BOOL __stdcall DES_RecordData(char portName[],WORD* data,DWORD bufferLength,DWORD* read,DWORD timeout,WORD jump);
CommandLayer_DllExport BOOL __stdcall DES_ReadNVariables(char portName[],WORD nbOfVariables,WORD*parNumbersAddresses,void* dataVector);

//CAN Functions
CommandLayer_DllExport BOOL __stdcall DES_ResetCANError(char portName[]);
CommandLayer_DllExport BOOL __stdcall DES_ResetCAN(char portName[]);
CommandLayer_DllExport BOOL __stdcall DES_SetModuleID(char portName[],WORD moduleID);
CommandLayer_DllExport BOOL __stdcall DES_SetTPDOID(char portName[],WORD transPDOID);
CommandLayer_DllExport BOOL __stdcall DES_SetRPDOID(char portName[],WORD receivePDOID);
CommandLayer_DllExport BOOL __stdcall DES_SendCANmsg(char portName[],WORD id,WORD dataA,WORD dataB,WORD dataC,WORD dataD);
CommandLayer_DllExport BOOL __stdcall DES_ReadModuleID(char portName[],WORD* moduleID);
CommandLayer_DllExport BOOL __stdcall DES_SetCAN_BCR1_BCR2(char portName[],WORD bcr1,WORD bcr2);
CommandLayer_DllExport BOOL __stdcall DES_SetCAN_Bitrate(char portName[],WORD index);
CommandLayer_DllExport BOOL __stdcall DES_ReadCANError(char portName[],WORD* error);
CommandLayer_DllExport BOOL __stdcall DES_GetRemoteData(char portName[],WORD id,BYTE opCode,WORD* param,BYTE nbOfParam,WORD* returnParam,BYTE nbOfReturnParam);
CommandLayer_DllExport BOOL __stdcall DES_ConfigPDO(char portName[],WORD action);
CommandLayer_DllExport BOOL __stdcall DES_SetRTRID(char portName[],WORD channel,WORD rtrID);
CommandLayer_DllExport BOOL __stdcall DES_ConfigRTR(char portName[],WORD channel,WORD action);
CommandLayer_DllExport BOOL __stdcall DES_AddRTRParameter(char portName[],WORD paramSel,WORD paramNbAddr,WORD* ack);
CommandLayer_DllExport BOOL __stdcall DES_GetRTRParameter(char portName[],WORD channel,WORD index,WORD* ack,WORD* format,WORD* paramNbAddr);


//Dialog Layer
//Status Functions
DialogLayer_DllExport BOOL __stdcall DES_ReadSysStatusDlg(char portName[]);
DialogLayer_DllExport BOOL __stdcall DES_ReadErrorDlg(char portName[]);
DialogLayer_DllExport BOOL __stdcall DES_EnableDlg(char portName[]);
//System Parameter Functions
DialogLayer_DllExport BOOL __stdcall DES_EditTempParamDlg(char portName[]);
DialogLayer_DllExport BOOL __stdcall DES_EditAllTempParamDlg(char portName[]);
DialogLayer_DllExport BOOL __stdcall DES_ReadVersionDlg(char portName[]);

//Setting Functions
DialogLayer_DllExport BOOL __stdcall DES_SetVelocityDlg(char portName[]);
DialogLayer_DllExport BOOL __stdcall DES_SetCurrentDlg(char portName[]);

//Monitor Functions
DialogLayer_DllExport BOOL __stdcall DES_ReadVelocityIsMustDlg(char portName[]);
DialogLayer_DllExport BOOL __stdcall DES_ReadCurrentIsMustDlg(char portName[]);

//Data Recording Functions
DialogLayer_DllExport BOOL __stdcall DES_SetupRecorderDlg(char portName[]);
DialogLayer_DllExport BOOL __stdcall DES_RecordDataDlg(char portName[]);
DialogLayer_DllExport BOOL __stdcall DES_ReadNVariablesDlg(char portName[]);

//CAN Functions
DialogLayer_DllExport BOOL __stdcall DES_ResetCANErrorDlg(char portName[]);
DialogLayer_DllExport BOOL __stdcall DES_ResetCANDlg(char portName[]);
DialogLayer_DllExport BOOL __stdcall DES_SetModuleIDDlg(char portName[]);
DialogLayer_DllExport BOOL __stdcall DES_SetTPDOIDDlg(char portName[]);
DialogLayer_DllExport BOOL __stdcall DES_SetRPDOIDDlg(char portName[]);
DialogLayer_DllExport BOOL __stdcall DES_SendCANmsgDlg(char portName[]);
DialogLayer_DllExport BOOL __stdcall DES_ReadModuleIDDlg(char portName[]);
DialogLayer_DllExport BOOL __stdcall DES_SetCAN_BCR1_BCR2Dlg(char portName[]);
DialogLayer_DllExport BOOL __stdcall DES_SetCAN_BitrateDlg(char portName[]);
DialogLayer_DllExport BOOL __stdcall DES_ReadCANErrorDlg(char portName[]);
DialogLayer_DllExport BOOL __stdcall DES_GetRemoteDataDlg(char portName[]);
DialogLayer_DllExport BOOL __stdcall DES_ConfigPDODlg(char portName[]);
DialogLayer_DllExport BOOL __stdcall DES_SetRTRIDDlg(char portName[]);
DialogLayer_DllExport BOOL __stdcall DES_SetRTRID0Dlg(char portName[]);
DialogLayer_DllExport BOOL __stdcall DES_SetRTRID1Dlg(char portName[]);
DialogLayer_DllExport BOOL __stdcall DES_ConfigRTRDlg(char portName[]);
DialogLayer_DllExport BOOL __stdcall DES_AddRTRParameterDlg(char portName[]);
DialogLayer_DllExport BOOL __stdcall DES_GetRTRParameterDlg(char portName[]);


//CAN Command Layer
//Status Functions
CAN_CommandLayer_DllExport BOOL __stdcall DES_CAN_ReadSysStatus(char portName[],WORD dest,WORD* sysStatus);
CAN_CommandLayer_DllExport BOOL __stdcall DES_CAN_ReadError(char portName[],WORD dest,WORD* error);
CAN_CommandLayer_DllExport BOOL __stdcall DES_CAN_ClearError(char portName[],WORD dest);
CAN_CommandLayer_DllExport BOOL __stdcall DES_CAN_Enable(char portName[],WORD dest,WORD enable);
CAN_CommandLayer_DllExport BOOL __stdcall DES_CAN_Reset(char portName[],WORD dest);

//System Parameter Functions
CAN_CommandLayer_DllExport BOOL __stdcall DES_CAN_ReadTempParam(char portName[],WORD dest,WORD parNb, WORD parType,void* param);
CAN_CommandLayer_DllExport BOOL __stdcall DES_CAN_SetTempParam(char portName[],WORD dest,WORD parNb, WORD parType,void* param);
CAN_CommandLayer_DllExport BOOL __stdcall DES_CAN_ResetTempParam(char portName[],WORD dest);
CAN_CommandLayer_DllExport BOOL __stdcall DES_CAN_SaveTempParam(char portName[],WORD dest);
CAN_CommandLayer_DllExport BOOL __stdcall DES_CAN_ReadAllTempParam(char portName[],WORD dest,DES_SysParam* sysParam);
CAN_CommandLayer_DllExport BOOL __stdcall DES_CAN_SetAllTempParam(char portName[],WORD dest,DES_SysParam* sysParam);
CAN_CommandLayer_DllExport BOOL __stdcall DES_CAN_ReadVersion(char portName[],WORD dest,WORD* softVersion,WORD* hardVersion,WORD versionGroup);
CAN_CommandLayer_DllExport BOOL __stdcall DES_CAN_SetDefaultSysParam(char portName[],WORD dest);

//Setting Functions
CAN_CommandLayer_DllExport BOOL __stdcall DES_CAN_SetVelocity(char portName[],WORD dest,short velocity);
CAN_CommandLayer_DllExport BOOL __stdcall DES_CAN_SetCurrent(char portName[],WORD dest,short current);
CAN_CommandLayer_DllExport BOOL __stdcall DES_CAN_StopMotion(char portName[],WORD dest);

//Monitor Functions
CAN_CommandLayer_DllExport BOOL __stdcall DES_CAN_ReadVelocityIsMust(char portName[],WORD dest,short* isVelocity, short* mustVelocity,WORD type);
CAN_CommandLayer_DllExport BOOL __stdcall DES_CAN_ReadCurrentIsMust(char portName[],WORD dest,short* isCurrentQAxis,short* isCurrentDAxis,short* mustCurrentAmp,short* rotorAngle,WORD type);

//CAN Functions
CAN_CommandLayer_DllExport BOOL __stdcall DES_CAN_ResetCANError(char portName[],WORD dest);
CAN_CommandLayer_DllExport BOOL __stdcall DES_CAN_ResetCAN(char portName[],WORD dest);
CAN_CommandLayer_DllExport BOOL __stdcall DES_CAN_SetModuleID(char portName[],WORD dest,WORD moduleID);
CAN_CommandLayer_DllExport BOOL __stdcall DES_CAN_SetTPDOID(char portName[],WORD dest,WORD transPDOID);
CAN_CommandLayer_DllExport BOOL __stdcall DES_CAN_SetRPDOID(char portName[],WORD dest,WORD receivePDOID);
CAN_CommandLayer_DllExport BOOL __stdcall DES_CAN_ReadModuleID(char portName[],WORD dest,WORD* id);
CAN_CommandLayer_DllExport BOOL __stdcall DES_CAN_SetCAN_BCR1_BCR2(char portName[],WORD dest,WORD bcr1,WORD bcr2);
CAN_CommandLayer_DllExport BOOL __stdcall DES_CAN_SetCAN_Bitrate(char portName[],WORD dest,WORD index);
CAN_CommandLayer_DllExport BOOL __stdcall DES_CAN_ConfigPDO(char portName[],WORD dest,WORD action);
CAN_CommandLayer_DllExport BOOL __stdcall DES_CAN_SetRTRID(char portName[],WORD dest,WORD channel,WORD rtrID);
CAN_CommandLayer_DllExport BOOL __stdcall DES_CAN_ConfigRTR(char portName[],WORD dest,WORD channel,WORD action);
CAN_CommandLayer_DllExport BOOL __stdcall DES_CAN_AddRTRParameter(char portName[],WORD dest,WORD paramSel,WORD paramNbAddr,WORD* ack);
CAN_CommandLayer_DllExport BOOL __stdcall DES_CAN_GetRTRParameter(char portName[],WORD dest,WORD channel,WORD index,WORD* ack,WORD*format,WORD* paramNbAddr);


//CAN Dialog Layer
//Status Functions
CAN_DialogLayer_DllExport BOOL __stdcall DES_CAN_ReadSysStatusDlg(char portName[],WORD dest);
CAN_DialogLayer_DllExport BOOL __stdcall DES_CAN_ReadErrorDlg(char portName[],WORD dest);
CAN_DialogLayer_DllExport BOOL __stdcall DES_CAN_EnableDlg(char portName[],WORD dest);

//System Parameter Functions
CAN_DialogLayer_DllExport BOOL __stdcall DES_CAN_EditTempParamDlg(char portName[],WORD dest);
CAN_DialogLayer_DllExport BOOL __stdcall DES_CAN_EditAllTempParamDlg(char portName[],WORD dest);

//Setting Functions
CAN_DialogLayer_DllExport BOOL __stdcall DES_CAN_SetVelocityDlg(char portName[],WORD dest);
CAN_DialogLayer_DllExport BOOL __stdcall DES_CAN_SetCurrentDlg(char portName[],WORD dest);

//Monitor Functions
CAN_DialogLayer_DllExport BOOL __stdcall DES_CAN_ReadVelocityIsMustDlg(char portName[],WORD dest);
CAN_DialogLayer_DllExport BOOL __stdcall DES_CAN_ReadCurrentIsMustDlg(char portName[],WORD dest);

//CAN Functions
CAN_DialogLayer_DllExport BOOL __stdcall DES_CAN_ResetCANDlg(char portName[],WORD dest);
CAN_DialogLayer_DllExport BOOL __stdcall DES_CAN_ResetCANErrorDlg(char portName[],WORD dest);
CAN_DialogLayer_DllExport BOOL __stdcall DES_CAN_ReadModuleIDDlg(char portName[],WORD dest);
CAN_DialogLayer_DllExport BOOL __stdcall DES_CAN_SetCAN_BCR1_BCR2Dlg(char portName[],WORD dest);
CAN_DialogLayer_DllExport BOOL __stdcall DES_CAN_SetCAN_BitrateDlg(char portName[],WORD dest);
CAN_DialogLayer_DllExport BOOL __stdcall DES_CAN_SetModuleIDDlg(char portName[],WORD dest);
CAN_DialogLayer_DllExport BOOL __stdcall DES_CAN_SetTPDOIDDlg(char portName[],WORD dest);
CAN_DialogLayer_DllExport BOOL __stdcall DES_CAN_SetRPDOIDDlg(char portName[],WORD dest);
CAN_DialogLayer_DllExport BOOL __stdcall DES_CAN_ConfigPDODlg(char portName[],WORD dest);
CAN_DialogLayer_DllExport BOOL __stdcall DES_CAN_SetRTRIDDlg(char portName[],WORD dest);
CAN_DialogLayer_DllExport BOOL __stdcall DES_CAN_SetRTRID0Dlg(char portName[],WORD dest);
CAN_DialogLayer_DllExport BOOL __stdcall DES_CAN_SetRTRID1Dlg(char portName[],WORD dest);
CAN_DialogLayer_DllExport BOOL __stdcall DES_CAN_ConfigRTRDlg(char portName[],WORD dest);
CAN_DialogLayer_DllExport BOOL __stdcall DES_CAN_AddRTRParameterDlg(char portName[],WORD dest);
CAN_DialogLayer_DllExport BOOL __stdcall DES_CAN_GetRTRParameterDlg(char portName[],WORD dest);

